#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityDBFCollectingCFG.h"
std::auto_ptr<M_ActivityDBFCollectingCFG> M_ActivityDBFCollectingCFG::msSingleton(nullptr);

int M_ActivityDBFCollectingCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityDBFCollectingCFGData* M_ActivityDBFCollectingCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityDBFCollectingCFGData>& M_ActivityDBFCollectingCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityDBFCollectingCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityDBFCollectingCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityDBFCollectingCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mCollectingType = element->IntAttribute("CollectingType");
		{
			const char* CollectingReward = element->Attribute("CollectingReward");
			std::vector<std::string> vecCollectingReward;
			boost::split(vecCollectingReward, CollectingReward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCollectingReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCollectingReward[i].c_str(), &temp))
				{
					data.mCollectingReward.push_back(temp);
				}
			}
		}
		{
			const char* CollectingQuantity = element->Attribute("CollectingQuantity");
			std::vector<std::string> vecCollectingQuantity;
			boost::split(vecCollectingQuantity, CollectingQuantity, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCollectingQuantity.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCollectingQuantity[i].c_str(), &temp))
				{
					data.mCollectingQuantity.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityDBFCollectingCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDBFCollectingCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityDBFCollectingCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityDBFCollectingCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityDBFCollectingCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "CollectingType", data.mCollectingType);
		LuaCfgHelper::readVectorInt(L, "CollectingReward", data.mCollectingReward);
		LuaCfgHelper::readVectorInt(L, "CollectingQuantity", data.mCollectingQuantity);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityDBFCollectingCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDBFCollectingCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityDBFCollectingCFG* M_ActivityDBFCollectingCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityDBFCollectingCFG());
	}
	return msSingleton.get();
}

void M_ActivityDBFCollectingCFG::Release()
{
	msSingleton.reset(nullptr);
}
